/**
 * 接口地址api，
 * 接口文档链接：http://www.xiaoyaoji.cn/doc/IxnvWtmCX
 */
const api = "https://api.hoolihome.com";

const apis = {
  api_upload_file: `${api}/common/upload/files`, //上传图片
  api_upload_del: `${api}/common/upload/del`, //删除图片
  api_wx_login: `${api}/jcgi/uuc/weapp/login`, // java微信登录
  api_mobile_code: `${api}/jcgi/uuc/common/sms/verifyCode`, // java发送验证码
  api_mobile_login: `${api}/jcgi/uuc/login`, // java手机登录
  api_user_update: `${api}/jcgi/uuc/user/update`, // java上传用户信息
  api_get_mobile_prefix: `${api}/common/address`,
  api_news_list: `${api}/jcgi/operation/portal/material/list`, // 文章列表
  api_category_list: `${api}/jcgi/operation/portal/material/category/list`, // 文章栏目,
  api_material_info: `${api}/jcgi/operation/portal/material/info`, // 文章详情
  api_material_history: `${api}/jcgi/operation/portal/user/material/history`, // 最近浏览
  api_share_qrCode: `${api}/jcgi/operation/portal/material/shareQrCode`, // 海报二维码
  api_comment_list: `${api}/jcgi/operation/portal/comment/list`, // 评论列表
  api_comment_add: `${api}/jcgi/operation/portal/user/comment/add`, // 评论
  api_material_like: `${api}/jcgi/operation/portal/user/material/like`, // 点赞
  api_topic_attention: `${api}/jcgi/operation/portal/user/attention/topic`, // 关注话题
  api_topic_attention_list: `${api}/jcgi/operation/portal/material/attention/topicList`, // 关注话题列表
  api_user_attention: `${api}/jcgi/operation/portal/user/attention/user`, // 关注用户
  api_user_attention_list: `${api}/jcgi/operation/portal/material/attention/userList`, // 关注用户列表
  api_msg_list: `${api}/jcgi/operation/portal/user/msg/list`, // 消息列表
  api_msg_info: `${api}/jcgi/operation/portal/user/msg/info`, // 已读状态
  api_topic_list: `${api}/jcgi/operation/portal/material/topicList`, // 话题列表
  api_material_topic_info: `${api}/jcgi/operation/portal/material/topicInfo`, // 话题详情
  api_topic_type_list: `${api}/jcgi/operation/portal/material/subjectTypeList`, // 话题标签
  api_tips_add: `${api}/jcgi/operation/portal/user/tips/add`, // 发帖
  api_tips_delete: `${api}/jcgi/operation/portal/user/tips/delete`, //删除帖子
  api_app_config: `${api}/jcgi/operation/portal/config/appConfig`, //配置
  api_user_fans_list: `${api}/jcgi/operation/portal/material/userFansList`, // 粉丝数列表
  api_user_info: `${api}/jcgi/operation/portal/material/userInfo`, // 用户信息
  api_comment_delete: `${api}/jcgi/operation/portal/user/comment/delete`, // 删除评论
  api_image_scan: `${api}/jcgi/operation/portal/user/tips/imageScan`, // 图片审核
};

for (const key in apis) {
  apis[key] = `${apis[key]}?apiVersion=1.1.1`;
}

module.exports = apis;
