// components/newCell/newCell.js
Component({
  /**
   * 组件的属性列表
   */
  properties: {
    data: {
      type: Object,
      value: {},
    },
    isHistory: {
      type: Boolean,
      value: false,
    },
    historyObj: {
      type: Object,
      value: {},
    },
  },

  /**
   * 组件的初始数据
   */
  data: {
    isLook: false,
  },
  /**
   * 组件的方法列表
   */
  methods: {
    handleCellAction() {
      const _this = this;
      const { id, type } = this.properties.data;
      // <!-- type = 1 文章  type = 2 视频  type = 3 帖子   -->
      if (parseInt(type) != 3) {
        wx.navigateTo({
          url: `/pages/newDetail/newDetail?newId=${id}`,
          success() {
            _this.setData({
              isLook: true,
            });
          },
        });
      }
    },
  },
});
